import java.io.*;
import java.net.*;


public class RASconnect {
	final static String version="0.6.0";
	final static int standardport=16345;
	private static Socket s;
    
	public static void main ( String[] args ) {
		String parameter="";
		String host="";
		int socketport;
		
		say("");
		say("  RASconnect Java-Client Version "+version);
		say("  (c) 2001 Christian Puritscher");
		if ( args.length<2 ) showsyntax();
		if (args[1].length()<2) showsyntax();
		parameter=args[1].substring(0,2).toLowerCase();
		if (!(parameter.equals("-v") || parameter.equals("-l") || parameter.equals("-c") || parameter.equals("-t") || parameter.equals("-i") || parameter.equals("-a"))) showsyntax();
				
		say("\n  Verbindung zum Server "+args[0]+" wird aufgebaut...");
		try {
			socketport = getport(args[0]);
			host=gethost(args[0]);
			if(host.equals("")) showsyntax();
			if((socketport<2000) || (socketport>30000)) die("Ungueltiger Port angegeben");
			s = new Socket(host, socketport);
		}
		catch(Exception e) {
			die("\n  Verbindung kann nicht aufgebaut werden. Stellen Sie sicher, dass der Server\n  auf dem angegebenen Rechner laeuft. Es wurden folgende weitere Informationen\n  geliefert:\n"+e);
		}
		say("  Die Verbindung zum Server wurde erfolgreich aufgebaut.");
		
		try {
			if (parameter.equals("-l")) logfileempfangen();
			else if (parameter.equals("-c")) verbindungherstellen(args);
			else if (parameter.equals("-t")) verbindungentrennen();
			else if (parameter.equals("-a")) verbindungchecken();
			else if (parameter.equals("-i")) ipdatenholen();
			else if (parameter.equals("-v")) listeempfangen();
		}
		catch(IOException e) {
			die("\n  Es trat folgender Fehler beim Verbindungsversuch auf:\n"+e);
		}
	}

	public static void listeempfangen() throws IOException {
		String temp="";
		say("\n  Folgende DFU-Verbindungen sind auf dem Server eingerichtet:");
		say("  (Sonderzeichen werden unter Umstaenden falsch dargestellt)");
		BufferedReader in_file = new BufferedReader(new InputStreamReader(s.getInputStream()));
		PrintStream out_file = new PrintStream(s.getOutputStream(), true);
		/*
		0001 Verbindungen aufzaehlen
		*/
		out_file.println("0001");
		while(true) { 
			temp=in_file.readLine();
			if (temp==null) continue;
			if (temp.length()>=4) if (temp.substring(0,4).equals("0000")) break;
			say("  '"+temp+"'");
		} 
		s.close();
		die(" ");
	}
	
	public static void verbindungherstellen(String[] temp2) throws IOException {
		int i,j;
		String verbindung="";
		String passwort="";
		String temp="";
		String temp3="";
		boolean erstesmal=true;
		for(int r=1;r<temp2.length;r++) temp=temp+" "+temp2[r];
		temp=temp.trim();
		i=temp.indexOf('/');
		j=temp.lastIndexOf('/');
		if ((i==-1) || (j==-1) || (i==j)) {
			s.close();
			showsyntax();
		}

		verbindung=temp.substring(i+1,j);
		passwort=temp.substring(j+1,temp.length());
		passwort=passwort.trim();
		say("  Die RAS-Verbindung wird zu '" + verbindung + "' hergestellt...");
		if(!passwort.equals("")) say("  Folgende Benutzerdaten werden benutzt: '"+passwort+"'");
		
		BufferedReader in_file = new BufferedReader(new InputStreamReader(s.getInputStream()));
		PrintStream out_file = new PrintStream(s.getOutputStream(), true);
		/*
		0002 Verbindungen herstellen
		*/
		out_file.println("0002"+"\""+verbindung+"\" "+passwort);
		say("");
		while(true) { 
			temp3=in_file.readLine();
			if (erstesmal) {
				say("--- Ereignisprotokoll (Anfang) ---");
				erstesmal=false;
			}
			if (temp3==null) continue;
			if (temp3.length()>=4) if (temp3.substring(0,4).equals("0000")) break;
			say("  " + temp3);
		} 
		say("--- Ereignisprotokoll (Ende) ---");
		s.close();
		die(" ");
	}
	
	public static void verbindungchecken() throws IOException {
		String temp="";
		boolean erstesmal=true;
		say("\n  Folgende DFU-Verbindungen sind auf dem Server aktiv:");
		say("  (Sonderzeichen werden unter Umstaenden falsch dargestellt)");
		BufferedReader in_file = new BufferedReader(new InputStreamReader(s.getInputStream()));
		PrintStream out_file = new PrintStream(s.getOutputStream(), true);
		/*
		0003 aktive Verbindungen aufzaehlen
		*/
		out_file.println("0003");
		say("");
		while(true) { 
			temp=in_file.readLine();
			if (erstesmal) {
				say("--- Ereignisprotokoll (Anfang) ---");
				erstesmal=false;
			}
			if (temp==null) continue;
			if (temp.length()>=4) if (temp.substring(0,4).equals("0000")) break;
			say("  " + temp);
		} 
		say("--- Ereignisprotokoll (Ende) ---");
		s.close();
		die(" ");
	}
	
	public static void verbindungentrennen() throws IOException {
		String temp="";
		boolean erstesmal=true;
		say("\n  Alle aktiven RAS-Verbindungen auf dem Server werden getrennt...");
		say("  Folgende RAS-Verbindungen sind jetzt noch aktiv:");
		BufferedReader in_file = new BufferedReader(new InputStreamReader(s.getInputStream()));
		PrintStream out_file = new PrintStream(s.getOutputStream(), true);
		/*
		0004 aktive Verbindungen trennen
		*/
		out_file.println("0004");
		say("");
		while(true) { 
			temp=in_file.readLine();
			if (erstesmal) {
				say("--- Ereignisprotokoll (Anfang) ---");
				erstesmal=false;
			}
			if (temp==null) continue;
			if (temp.length()>=4) if (temp.substring(0,4).equals("0000")) break;
			say("  " + temp);
		} 
		say("--- Ereignisprotokoll (Ende) ---");
		s.close();
		die(" ");
	}
	
	public static void ipdatenholen() throws IOException {
		String temp="";
		boolean erstesmal=true;
		say("\n  Folgende IP-Konfiguration ist auf dem Server aktuell:");
		say("  (Sonderzeichen werden unter Umstaenden falsch dargestellt)");
		BufferedReader in_file = new BufferedReader(new InputStreamReader(s.getInputStream()));
		PrintStream out_file = new PrintStream(s.getOutputStream(), true);
		/*
		0005 IP-Daten holen
		*/
		out_file.println("0005");
		say("");
		while(true) { 
			temp=in_file.readLine();
			if (erstesmal) {
				say("--- Ereignisprotokoll (Anfang) ---");
				erstesmal=false;
			}
			if (temp==null) continue;
			if (temp.length()>=4) if (temp.substring(0,4).equals("0000")) break;
			say("  " + temp.trim());
		} 
		say("--- Ereignisprotokoll (Ende) ---");
		s.close();
		die(" ");
	}
	
	public static void logfileempfangen() throws IOException {
		String temp="";
		boolean erstesmal=true;
		say("\n  Folgende Aktionen wurden auf dem Server geloggt:");
		say("  (Sonderzeichen werden unter Umstaenden falsch dargestellt)");
		BufferedReader in_file = new BufferedReader(new InputStreamReader(s.getInputStream()));
		PrintStream out_file = new PrintStream(s.getOutputStream(), true);
		/*
		0006 Logfile holen
		*/
		out_file.println("0006");
		say("");
		while(true) { 
			temp=in_file.readLine();
			if (erstesmal) {
				say("--- Ereignisprotokoll (Anfang) ---");
				erstesmal=false;
			}
			if (temp==null) continue;
			if (temp.length()>=4) if (temp.substring(0,4).equals("0000")) break;
			say("  " + temp);
		} 
		say("--- Ereignisprotokoll (Ende) ---");
		s.close();
		die(" ");
	}
	
	
	public static int getport(String rohstring) {
		int res=-1;
		if(rohstring.indexOf(":")==-1) return standardport;
		try {
			res=Integer.parseInt(rohstring.substring(rohstring.indexOf(":")+1));
		}
		catch (Exception e) {
			return -1;
		}
		return res;
	}
	
	public static String gethost(String rohstring) {
		if(rohstring.indexOf(":")==-1) return rohstring;
		return (rohstring.substring(0, rohstring.indexOf(":")));
	}
	
	public static void showsyntax() {
		say("");
		say("  Steuert die DFU-Verbindungen eines Windows NT/2000/XP Servers");
		say("");
		say("  Syntax:");
		say("  RASconnect SERVER[:PORT] OPTION");
		say("  wobei SERVER der Hostname oder die IP-Adresse des Windows-Servers ist, und");
		say("  OPTION eine der folgenden Optionen ist");
		say("    -v   Listet alle verfuegbaren DFU-Verbindungen auf");
		say("    -a   Listet alle aktiven DFU-Verbindungen auf");
		say("    -c /Name der DFU-Verbindung/ [Benutzername] [Passwort]");
		say("         Stellt die Verbindung mit der angegebenen DFU-Verbindung her");
		say("         und benutzt dabei die optional angegebenen Logininformationen");
		say("    -t   Auflegen aller DFU-Verbindungen");
		say("    -l   Server-Logfile anzeigen");
		say("    -i   Anzeigen der IP-Konfiguration des Servers");		
		say("");
		say("  Beispiele:");
		say("  RASconnect 192.168.2.4 -l");
		say("  RASconnect localhost:2015 -c /Freenet/");
		say("  RASconnect localhost -c /T-Online/ 000012456789012 meinPasswort");
		System.exit(0);
	}

	public static void die(String t) {
		System.out.println(t);
		System.exit(0);
	}
	
	public static void say(String t) {
		println(t);
	}
	
	public static void println(String st) {		
		try {			
			OutputStreamWriter out = new OutputStreamWriter(System.out, "Cp850");			
			out.write(st + "\n");
			out.flush();		
		}
		catch (Exception io) {}	
	}
	
	public static String stringreplace (String eingabe, String ersetzenvon, String ersetzenmit) {
		String temp1;
		String temp2;
		while((eingabe.indexOf(ersetzenvon)!=-1) && !ersetzenvon.equals("")) {
			temp1=eingabe.substring(0,eingabe.indexOf(ersetzenvon));
			temp2=eingabe.substring(eingabe.indexOf(ersetzenvon)+ersetzenvon.length());
			eingabe=temp1+ersetzenmit+temp2;
		}
		return eingabe;
	}
}
	